/* ICB1IO.C  icb protcol 1 i/o functions */

#ifndef EVERYTHING
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <fcntl.h>
#include <stdio.h>
#include <signal.h>
#include <netdb.h>
#include <time.h>
#include <errno.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>

#ifndef FIONREAD
#include <sys/filio.h>
#endif /* of ifndef FIONREAD */
#endif /* of ifndef EVERYTHING */

int cur_socket;
int gotsigpipe;
int carrier;
long timer[2];
char stuff[4][255];
char *bigbuf;

void got_sigpipe ( signum ) int signum; {
  gotsigpipe = signum;
  }

void catch_sig()  {  
  signal ( SIGPIPE, got_sigpipe );
  }

void init_timer() { 
  struct timeb foo;
  ftime(&foo);
  timer[0] = foo.time;
  timer[1] = foo.millitm;
  }

long elapsed() {
  long done[2];
  struct timeb foo;
  long retval;

  ftime ( &foo );
  done[0] = foo.time;
  done[1] = foo.millitm;
  if ( timer[1] > done[1] ) {
     done[0]--;
     done[1] += 1000;
  }
  retval = ( ( done[0] - timer[0] ) * 1000 ) +
             ( done[1] - timer[1] );
  if ( done[1] >= 1000 ) {
     done[0]++;
     done[1] -= 1000;
  }
  timer[0] = done[0];
  timer[1] = done[1];
  return retval;
  }

long sofar() {
  long done[2];
  struct timeb foo;
  long retval;

  ftime ( &foo );
  done[0] = foo.time;
  done[1] = foo.millitm;
  if ( timer[1] > done[1] ) {
     done[0]--;
     done[1] += 1000;
  }
  retval = ( ( done[0] - timer[0] ) * 1000 ) +
             ( done[1] - timer[1] );
  return retval;
  }

int client_socket ( d0, d1, d2, d3, pnum ) 
  unsigned char d0, d1, d2, d3; 
  unsigned short pnum;
  {  int    i, s;
     struct sockaddr_in sin;

     carrier = 0;
     if((s=socket(AF_INET, SOCK_STREAM, 0))==-1) {
       perror("clientsocket: socket() error ");
       return ( -1 );
       }
     memset ( &sin, 0, sizeof(sin) ); 
     ((unsigned char*)(&sin.sin_addr.s_addr))[0] = d0;
     ((unsigned char*)(&sin.sin_addr.s_addr))[1] = d1;
     ((unsigned char*)(&sin.sin_addr.s_addr))[2] = d2;
     ((unsigned char*)(&sin.sin_addr.s_addr))[3] = d3;
     sin.sin_family = AF_INET;
     sin.sin_port = htons ( pnum );
     if( connect ( s, (struct sockaddr*) &sin, sizeof(sin) ) == -1 ) { 
       perror("client_socket: connect() error ");
       return ( -1 );
       }
     catch_sig();
     init_timer();
     carrier = 1;
     return ( s );
     }

int clientsocket ( dest, pnum ) char *dest; unsigned short pnum;
  {  int    i, s;
     struct sockaddr_in sin;
     unsigned long foo;
     struct hostent *zeeaddrezz;

     carrier = 0;
     if((s=socket(AF_INET, SOCK_STREAM, 0))==-1) {
       perror("clientsocket: socket() error ");
       return ( -1 );
       }
     memset ( &sin, 0, sizeof(sin) ); 
     zeeaddrezz = gethostbyname ( dest );
     if ( zeeaddrezz == NULL ) {
        perror("clientsocket: gethostbyname() error");
        return ( -1 );
        }
     ((unsigned char*)(&sin.sin_addr.s_addr))[0] =
     ((unsigned char*)(zeeaddrezz->h_addr))[0],
     ((unsigned char*)(&sin.sin_addr.s_addr))[1] =
     ((unsigned char*)(zeeaddrezz->h_addr))[1],
     ((unsigned char*)(&sin.sin_addr.s_addr))[2] =
     ((unsigned char*)(zeeaddrezz->h_addr))[2],
     ((unsigned char*)(&sin.sin_addr.s_addr))[3] =
     ((unsigned char*)(zeeaddrezz->h_addr))[3],
     sin.sin_family = AF_INET;
     sin.sin_port = htons ( pnum );
     if( connect ( s, (struct sockaddr*) &sin, sizeof(sin) ) == -1 ) { 
       perror("clientsocket: connect() error ");
       return ( -1 );
       }
     catch_sig();
     init_timer();
     carrier = 1;
     return ( s );
     }

int checkfd ( fd ) int fd; {  
  int    one = 1;
  fd_set hand;
  struct timeval foo;
  int    result;

  FD_ZERO ( &hand );
  FD_SET  ( fd, &hand );
  foo.tv_sec  = 0;
  foo.tv_usec = 0;
  result = select ( 8, &hand, NULL, NULL, &foo );
  if ( result < 0 ) carrier = 0;
  return ( FD_ISSET ( fd, &hand ) );
  }

void split ( buf, iter ) unsigned char *buf; int iter; {
  int   i,n,k;

  n = 0; 
  for ( i = 0; i < iter; i++ ) {
    k = 0;
    while ( buf[n] > 1 ) {
      stuff[i][k] = buf[n];
      k++; n++;
      } /* end of while */
    stuff[i][k] = 0; n++;
    } /* end of for */
  k = 0;
  while ( buf[n] ) {
    stuff[i][k] = buf[n]; k++; n++;
    } /* end of while */
  stuff[i][k] = 0;
  } /* end of function split() */

void readpacket ( fd, kind ) int fd; char *kind; {
  unsigned char len;
  char          buf[256];
  int           i,j,k;
  int           result;

  len = 0; i = 0;
  if ( !carrier ) return;
  read ( fd, &len, 1 );
  while ( i < len ) {
    result = read ( fd,  buf+i, ((int)len)-i );
    if ( result < 1 ) {
      carrier = 0;
      return;
      }
    i += result;
    }
  buf[len] = 0;
  stuff[0][0] = 0;
  stuff[1][0] = 0;
  stuff[2][0] = 0;
  stuff[3][0] = 0;
  *kind = buf[0];
  switch ( buf[0] ) {
    case 'a' : break; /* login verification */
    case 'b' : split ( buf+1, 1 );  break; /* public  message */
    case 'c' : split ( buf+1, 1 );  break; /* private message */
    case 'g' : break; /* exit. now. or incur the server's wrath! */
    case 'j' : break; /* protocol check. */
    case 'd' : split ( buf+1, 1 );  break; /* status  message */
    case 'i' : split ( buf+1, 1 );  break; /* command message */
    default  : k = strlen(buf+1); 
               for (j=0;j<k;j++) stuff[0][j] = buf[j+1]; 
               stuff[0][k] = 0; break;
    } /* end of switch */
  } /* end of function readpacket() */

void writepub ( fd, msg ) int fd; char *msg; {
  unsigned char buf[255];
  unsigned char foo;
  int begin, end, i, k, quit, lfo;

  if(debug)
    printf ("writepub: pre-alpha\n");

  quit = 0;

  if(debug)
    printf ("writepub: pre-beta %d\n", (long) msg );

  k = strlen ( msg );

  if(debug)
    printf ("writepub: pre-gamma, message size is %d\n", k);

  if ( k > 245 ) {
    if(debug)
      printf ("writepub: alpha\n");

    begin = 0;
    end   = 244;
    while ( !quit ) {
      if(debug)
        printf ("writepub: beta\n");

      while ( ( end > (begin+1) ) && ( msg[end] != ' ' ) ) 
        end--;

      if(debug)
        printf ("writepub: gamma\n");

      for ( i = begin; i < end; i++ ) buf[i-begin] = msg[i];

      if(debug)
        printf ("writepub: delta\n");

      buf[i-begin] = 0;

      if(debug)
        printf ("writepub: epsilon\n");

      writepub ( fd, buf );

      if(debug)
        printf ("writepub: iota\n");

      if ( ( k - end ) < 246 ) {
        if(debug)
           printf ("writepub: kappa\n");

        quit = 1;
        for ( i = end; i < k; i++ ) buf[i-end] = msg[i];
        buf[i-end] = 0;
        writepub ( fd, buf );
        if ( bigbuf != NULL ) { free ( bigbuf ); bigbuf = NULL; } /* zzapp */
        } else {
        begin = end;
        end = begin + 244;
	} /* end of if..else */
      } /* end of while */
    if(debug)
       printf ("writepub: lambda\n");

    return;
    } /* end of if */
  if ( !msg[0] ) return;
  sprintf ( buf, " b%s%c", msg, 0 );
  foo = strlen ( buf );
  lfo = strlen ( buf );
  if(debug)
  {
     printf ("writepub: nu, final packet is size %u\n",lfo);
     printf ("writepub: om, final packet is size %u\n",foo);
  }
  buf[0] = foo;
  write ( fd, buf, foo + 1);
}

void writecmd ( fd, what, who, msg ) 
  int fd; char *what, *who, *msg; {
  unsigned char shuttle[256];
  unsigned char foo;

  shuttle[0] = 0;
  sprintf ( shuttle, " h%s%c", what, 1 );
  if ( who != NULL ) 
    strcat ( shuttle, who );
  if ( msg != NULL ) {
    if ( who != NULL ) strcat ( shuttle, " " );
    strcat ( shuttle, msg );
    }
  foo = strlen ( shuttle );
  if(debug)
    printf ("writecmd: '%s'", shuttle );

  shuttle[0] = foo;
  write ( fd, shuttle, foo + 1 );
  }

void gotogroup ( fd, which ) int fd; char *which; {
  writecmd ( fd, "g", NULL, which );
  }

void settopic ( fd, what ) int fd; char *what; {
  writecmd ( fd, "topic", NULL, what );
  }

void passmod ( fd, who ) int fd; char *who; {
  writecmd ( fd, "pass", who, NULL );
  }

void writepriv ( fd, who, msg ) int fd; char *who; char *msg; {
  unsigned char buf[256];
  int begin, end, i, k, kw, quit;

  if(debug)
  {
    printf ("writepriv: msg    is %u\n", (long) msg );
    printf ("writepriv: bigbuf is %u\n", (long) bigbuf );
  }
  quit = 0;
  kw = strlen ( who );
  k  = strlen ( msg ) + kw;
  if ( k > 245 ) {
    begin = 0;
    end   = 244 - kw;
    while ( !quit ) {
      while ( ( end > (begin+1) ) && ( msg[end] != ' ' ) ) end--;
      for ( i = begin; i < end; i++ ) buf[i-begin] = msg[i];
      buf[i-begin] = 0;
      writepriv ( fd, who, buf );
      if ( ( k - end ) < 246 ) {
        quit = 1;
        for ( i = end; i < k; i++ ) buf[i-end] = msg[i];
        buf[i-end] = 0;
        writepriv ( fd, who, buf );
        if ( bigbuf != NULL ) { free ( bigbuf ); bigbuf = NULL; } /* zzapp */
        } else {
        begin = end;
        end = begin + 244 - kw;
        } /* end of if..else */
      } /* end of while */
    return;
    } /* end of if */

  writecmd ( fd, "m", who, msg );
  }

void writemail(fd,who,msg) int fd; char *who; char *msg; {
  unsigned char buf[256];
  int begin, end, i, k, kw, quit;

  quit = 0;
  kw = strlen ( who );
  k  = strlen ( msg ) + kw;
  if ( k > 245 - kw ) {
    begin = 0;
    end   = 244 - kw;
    while ( !quit ) {
      while ( ( end > (begin+1) ) && ( msg[end] != ' ' ) ) end--;
      for ( i = begin; i < end; i++ ) buf[i-begin] = msg[i];
      buf[i-begin] = 0;
      writemail ( fd, who, buf );
      if ( ( k - end ) < 246 - kw ) {
        if ( ( k - end ) < 1 ) return;
        quit = 1;
        for ( i = end; i < k; i++ ) buf[i-end] = msg[i];
        buf[i-end] = 0;
        writemail ( fd, who, buf );
        if ( bigbuf != NULL ) { free ( bigbuf ); bigbuf = NULL; } /* zzapp */
        } else {
        begin = end;
        end = begin + 244 - kw;
        } /* end of if..else */
      } /* end of while */
    return;
    } /* end of if */

  writecmd(fd,"write",who,msg);
  }

void login ( fd, name, nick, group, cmd, pass ) 
  int fd; char *name, *nick, *group, *cmd, *pass; 
  {  unsigned char buf[256];
     unsigned char foo;

     if ( strlen ( name  ) +
          strlen ( nick  ) +
          strlen ( group ) +
          strlen ( cmd   ) +
          strlen ( pass  ) > 247 ) return;
     sprintf ( buf, " a%s%c%s%c%s%c%s%c%s%c",
               name, 1, nick, 1, group, 1, cmd, 1, pass, 0 );
     foo = strlen ( buf );
     buf[0] = foo;
     write ( fd, buf, foo + 1 );
     }



